<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
    xmlns:as="http://www.oasis-open.org/committees/cam"
    xmlns:camed="http://jcam.org.uk/editor"
    xmlns:as-xsl="http://www.oasis-open.org/committees/cam/xslt"
    exclude-result-prefixes="xs xd as camed as-xsl"
    version="2.0">
    <xd:doc scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> Mar 19, 2013</xd:p>
            <xd:p><xd:b>Author:</xd:b> Serge Leontiev</xd:p>
            <xd:p></xd:p>
        </xd:desc>
    </xd:doc>
    
    <xsl:output indent="yes" method="xml" encoding="UTF-8" />
       
    <xsl:template match="/">
        <xsl:comment>Autogenerated from CAM template by XSLT (version 1.0)
            CAM Template HEADER information: 
                    
            Description: <xsl:value-of select="//as:Header/as:Description"/> 
            Owner: <xsl:value-of select="//as:Header/as:Owner"/>
            Date: <xsl:value-of select="//as:Header/as:DateTime"/>
            Version: <xsl:value-of select="//as:Header/as:Version"/>            
        </xsl:comment>
        <xsl:element name="CAMReport">            
            <xsl:apply-templates select="//as:AssemblyStructure/as:Structure"/>   
        </xsl:element>
    </xsl:template>
    
    <xsl:template match="as:Structure">        
        <xsl:apply-templates select="*"/>
    </xsl:template>
    
    <xsl:template match="*"> 
        <xsl:element name="Entry">            
            <xsl:variable name="parentName" select="name(parent::node())"/>
            <xsl:variable name="nodeName" select="name()"/>
            <xsl:element name="Parent">
                <xsl:value-of select="if($parentName = 'as:Structure') then '/' else $parentName"/>
            </xsl:element>
            <xsl:element name="Item">
                <xsl:value-of select="$nodeName"/>
            </xsl:element>
            <xsl:element name="Depth">
                <xsl:value-of select="count(ancestor::*)-3"/>
            </xsl:element>
            <xsl:element name="Rules">
                <xsl:apply-templates select="//as:constraint[matches(@action, concat('\(//', $parentName,'/', $nodeName, '\)|\(//', $parentName,'/', $nodeName,',|\(//', $parentName,'/', $nodeName,'/\*\[|\(//', $nodeName, '/\*\['))]"/>        
                <xsl:value-of>&#xA;</xsl:value-of>                    
            </xsl:element>
            <xsl:element name="Annotations">
                <xsl:apply-templates select="//camed:annotation[@item = concat('//', $parentName,'/', $nodeName)]"/>
            </xsl:element>
        </xsl:element>
        <xsl:apply-templates select="@*"/>
        <xsl:apply-templates select="*"/>
        
    </xsl:template>
    
    <xsl:template match="@*">
        <xsl:element name="Entry">            
            <xsl:variable name="parentName" select="if(name(parent::node()/parent::node()) = 'as:Structure') then name(parent::node()) else concat(name(parent::node()/parent::node()), '/', name(parent::node()))"/>
            <xsl:variable name="immediateParentName" select="name(parent::node())"/>
            <xsl:variable name="nodeName" select="concat('@', name())"/>
            <xsl:element name="Parent">
                <xsl:value-of select="$immediateParentName"/>
            </xsl:element>
            <xsl:element name="Item">
                <xsl:value-of select="$nodeName"/>
            </xsl:element>
            <xsl:element name="Depth">
                <xsl:value-of select="count(ancestor::*)-3"/>
            </xsl:element>
            <xsl:element name="Rules">
                <xsl:apply-templates select="//as:constraint[matches(@action, concat('\(//', $parentName,'/', $nodeName, '\)|\(//', $parentName,'/', $nodeName,','))]"/>        
                <xsl:value-of>&#xA;</xsl:value-of>                    
            </xsl:element>
            <xsl:element name="Annotations">
                <xsl:apply-templates select="//camed:annotation[@item = concat('//', $immediateParentName, '/', $nodeName)]"/>
            </xsl:element>
        </xsl:element>        
    </xsl:template>
       
    <xsl:template match="camed:annotation">
        <xsl:for-each select="*">
            <xsl:element name="{@type}">
                <xsl:value-of select="."/>
            </xsl:element>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="as:constraint">

        <xsl:variable name="actionDetails" as="element(Action)">
            <xsl:element name="Action">
                <xsl:analyze-string select="string(@action)" regex="([a-zA-Z]+)\((/.+[\[].+[\]]|/.[^,]+)[,]?(.[^,]+)?[,]?(.[^,]+)?\)">
                    <xsl:matching-substring>
                        <xsl:attribute name="type" select="regex-group(1)"/>
                        <xsl:attribute name="param" select="regex-group(3)"/>
                        <xsl:attribute name="default" select="regex-group(4)"/>
                    </xsl:matching-substring>
                </xsl:analyze-string>                
            </xsl:element>
        </xsl:variable>

        <xsl:value-of>            
            <xsl:choose>            
                <xsl:when test="@condition">
                    <xsl:value-of>if <xsl:value-of select="@condition"/> then <xsl:value-of select="'&#xA;'"/></xsl:value-of> 
                    <xsl:choose>
                        <xsl:when test="not(contains(@action,'lookup('))">     			
                            <xsl:value-of><xsl:value-of select="$actionDetails/@type"/>(<xsl:value-of select="$actionDetails/@param"/>)</xsl:value-of>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of>
                            lookup(
                                <xsl:value-of select="substring-before(substring-after(@action,'lookup('),')')"/>
                                <xsl:value-of select="substring-after(@action,'lookup(')"/>)
                            </xsl:value-of>
                        </xsl:otherwise>
                    </xsl:choose>
                    <xsl:value-of select="'&#xA;'"/>
                    <xsl:value-of> end if;</xsl:value-of>      							
                </xsl:when>
                <xsl:otherwise>
                    <xsl:choose>
                        <xsl:when test="$actionDetails/@type = 'makeMandatory'">     			
                            <xsl:value-of>required item</xsl:value-of>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'makeRepeatable'">     			
                            <xsl:value-of>repeatable item</xsl:value-of>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'makeOptional'">     			
                            <xsl:value-of>optional</xsl:value-of>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'datatype'">     
                            <xsl:choose>
                                <xsl:when test="$actionDetails/@param = 'any'">
                                    <xsl:value-of>with content type of &quot;<xsl:value-of select="$actionDetails/@param"/>&quot;</xsl:value-of>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:value-of>with data type of &quot;<xsl:value-of select="$actionDetails/@param"/>&quot;</xsl:value-of>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'setNumberMask'">     
                            <xsl:choose>
                                <xsl:when test="contains($actionDetails/@param,'.')">
                                    <xsl:value-of>decimal number with format &quot;<xsl:value-of select="$actionDetails/@param"/>&quot;</xsl:value-of>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:value-of>numeric with format &quot;<xsl:value-of select="$actionDetails/@param"/>&quot;</xsl:value-of>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:when test="contains($actionDetails/@type,'exclude')">     			
                            <xsl:value-of>* E X C L U D E D *</xsl:value-of>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'setLimit'">     			
                            <xsl:value-of>repeat limited to only <xsl:value-of select="$actionDetails/@param"/>  times</xsl:value-of>
                        </xsl:when>
                        <!-- Need to add whitespace to minimize table column width when lots of enumerated values. -->
                        <xsl:when test="$actionDetails/@type = 'restrictValues'">     			
                            <xsl:value-of>Only allowed values are: <xsl:value-of select="replace($actionDetails/@param, '[|]', ' | ')" />
                            <xsl:if test="not($actionDetails/@default = '')">
                                <xsl:value-of> default value is <xsl:value-of select="$actionDetails/@default"/></xsl:value-of>
                            </xsl:if>
                            </xsl:value-of>
                        </xsl:when>
                        <xsl:when test="$actionDetails/@type = 'setChoice'">                
                            <xsl:variable name="choices" select="tokenize(substring-after(@action,'['),'''\)')"/>
                            <xsl:value-of>choice item within <xsl:value-of select="substring-before(substring-after(@action,'//'),'/*')"/> (one of <xsl:for-each select="$choices">
                                    <xsl:choose>
                                        <xsl:when test="contains(.,'),')"> - <xsl:value-of select="substring-after(.,'),''')"/></xsl:when>
                                        <xsl:otherwise> - <xsl:value-of select="substring-after(.,'=''')"/></xsl:otherwise>
                                    </xsl:choose> 
                                </xsl:for-each>)</xsl:value-of>
                        </xsl:when>
                        <xsl:when test="not($actionDetails/@type = 'lookup')">
                            <xsl:value-of><xsl:value-of select="$actionDetails/@type"/>(<xsl:value-of select="$actionDetails/@param"/>)</xsl:value-of>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:choose>
                                <xsl:when test="contains(@action,',')"><xsl:value-of select="substring-before(@action,',')"/>,<xsl:value-of select="substring-before(substring-after(@action,','),')')"/><xsl:value-of select="substring-after(@action,',')"/></xsl:when>
                                <xsl:otherwise><xsl:value-of select="@action"/></xsl:otherwise>
                            </xsl:choose>	
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="'&#xA;'"/>
        </xsl:value-of>
    </xsl:template>

</xsl:stylesheet>